/*
 * NoCoincideLongitudoTipoCampoAlfanumericoNumericoObligatorioDepEmpiezaCeroValidaTC.java
 *
 * Created on 7 de abril de 2007, 03:01 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.fidufosyga.rules;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 
 * @author Julian
 */
public class NoCoincideLongitudoTipoCampoAlfanumericoNumericoObligatorioDepEmpiezaCeroValidaTC
		extends AbstractRule {

	private Pattern pattern;

	public NoCoincideLongitudoTipoCampoAlfanumericoNumericoObligatorioDepEmpiezaCeroValidaTC() {
		String patternStr = "[^A-Z0-9/Ñ]";
		pattern = Pattern.compile(patternStr);

	}

	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {

		if (registro[new Integer((String) getParams()[0]).intValue()]
				.equals(getParams()[1])) {

			// EACG.30/03/2009.INI.A19115.Ajustes Malla Validadora, valida Tipo
			// Cotizante.
			if (registro[11].equalsIgnoreCase("3")
					|| registro[11].equalsIgnoreCase("4")) {
				if ((registro[3].equalsIgnoreCase(registro[20]))
						&& (registro[4].equalsIgnoreCase(registro[21]))) {
					return false;
				}
			}
			// EACG.30/03/2009.INI.A19115.

			if (field.length() < new Integer((String) getParams()[2])
					.intValue()
					|| field.length() > new Integer((String) getParams()[3])
							.intValue())
				return true;
			if (field.charAt(0) == ('0')) {
				return true;
			}
			Matcher matcher = pattern.matcher(field);
			return matcher.find();

		}

		return false;
	}

}
